var doc = jQuery(document),
    body = jQuery('body'),
    win = jQuery(window);

(function ($) {
    doc.ready(function () {

        $('select').select2({dropdownAutoWidth: true, 'width':'100%'});
        // => TOOLTIP
        $toolTip = $('.inputTooltip');
        $toolTip.on('focus', function () {
            $('.tooltip').addClass('open');
        });
        $toolTip.on('focusout', function () {
            $('.tooltip').removeClass('open');
        });

        /*============================> html files includes*/
        w3IncludeHTML();

        /*============================> style select*/
        // $(".styledSelect").selectmenu();

        /*============================> datepicker*/
        // $("#datepicker").datepicker();


        //------------------STICKY HEADER

        if (window.matchMedia("(min-width: 1024px)").matches) {
            win.on('scroll', function (event) {
                var scrollTop = $(this).scrollTop(),
                    breadcrumb = $('.breadcrumbContainer'),
                    stickheader = $('.header');
                if (scrollTop > 180) {
                    stickheader.stop().addClass('sticky');
                    breadcrumb.stop().addClass('sticky');
                }
                else {
                    stickheader.stop().removeClass('sticky');
                    breadcrumb.stop().removeClass('sticky');
                }
            });
        }

        //------------------SIDEBAR HEADER
        if (window.matchMedia("(min-width: 1024px)").matches) {
            win.on('scroll', function (event) {
                var scrollTop = $(this).scrollTop(),
                    sidebar = $('.sidebar .nav-stacked'),
                    elementPosition = sidebar.offset(),
                    elementWidth = sidebar.outerWidth();
                if (scrollTop > 180) {
                    sidebar
                        .stop()
                        .addClass('sticky')
                        .css('top', '180px')
                        .css('left', elementPosition.left)
                        .css('width', elementWidth);
                }
                else {
                    sidebar.stop().removeClass('sticky');
                }
            });
        }

        //-------------------- MENU MOBILE
        if (window.matchMedia("(max-width: 1179px)").matches) {
            $('.menuBurger').click(function (e) {
                e.preventDefault();
                $(this).toggleClass('on');
                $('body').toggleClass('openSidebar');
                $('nav.mainNav').toggleClass('opened');
            });
            $('#wrapSiteHide').click(function (e) {
                $('body').removeClass('openSidebar');
                $('nav.mainNav').removeClass('opened');
            });

            //Find subMenus
            var rootMenu = '.mainNav li';
            $(rootMenu).each(function () {
                if ($(this).has("ul").length) {
                    $(this).addClass('hasSubMenu');
                }
            });

            var subMenuList = '.mainNav li.hasSubMenu';
            $(subMenuList).each(function () {
                if ($(this).has("ul").length) {
                    $(this).children('ul').addClass('blocMenu');
                }
            });

            //pour les sous-menus a depoiement vertical
            $('.hasSubMenu > div > a').click(function (e) {
                e.preventDefault();
                /*$('nav.mainNav').css({
                 height: 'inherit',
                 bottom: 'inherit'
                 });*/
                if (!$(this).parent().parent().hasClass('fold')) {
                    $(this).parent().parent().children('ul').addClass("open");
                    $(this).parent().parent().children('ul').addClass("open");
                }
            });
            $('.hasSubMenu.fold > div .arrowR').click(function (e) {
                e.preventDefault();
                $(this).toggleClass('unfold');
                var parentFold = $(this).parent().parent().children('ul');
                if (parentFold.hasClass("openFold")) {
                    parentFold.removeClass("openFold").addClass('openUnfold');
                } else {
                    parentFold.addClass("openFold").removeClass("openUnfold");
                }
                if ($(this).hasClass("unfold")) {
                    $(this).parent("div").css({
                        'border-bottom': "1px solid rgba(0, 0, 0, 0.8)"
                    });
                }
                else {
                    $(this).parent("div").css({
                        'border-bottom': "none"
                    });
                }
            });

            //pour le retour menu precedent
            $('.backMenu a').click(function (e) {
                e.preventDefault();
                if ($(this).hasClass('navHome')) {
                    $('nav.mainNav').css({
                        height: '100%',
                        bottom: 0
                    });
                }
                $(this).parent().parent().removeClass('open');
                //console.log();
            });
        }

        $('[data-add-bookmark]').click(function (e) {
            e.preventDefault();
            var elem = $(this);
            $.ajax({
                url: elem.prop('href'),
                data: 'url=' + elem.data('url'),
                method: "POST",
                dataType: 'JSON',
                success: function (data) {
                }
            });
        });


        doc.on('click', '.btn-file[data-target-input]', function (e) {
            var btn = $(this);
            e.preventDefault();
            $('#' + btn.data('target-input')).trigger('click');
        });

        doc.on('change', 'input[type="file"]', function (e) {
            var input = $(this),
                fakeInput = $('[data-fake-input="' + input.prop('id') + '"]');

            if (fakeInput.length > 0) {
                fakeInput.val(input.val());
            }
        });


        doc.on('click', '.export-action [data-modal], .btn-group [data-modal], .btn-custom[data-modal], .btnLv1[data-modal]', function (e) {
            var elem = $(this), myModal = $("#bydedi_custom_modal");
            myModal.find(".modal-title").html(elem.html());
            showLoader(myModal.find(".modal-body"));
            myModal.modal('show');
            myModal.find(".modal-body").load(elem.data("target"));
        });

        doc.on('click', '.export-action [data-confirm]', function (e) {
            var elem = $(this), myModal = $("#bydedi_custom_modal");
            if (confirm(elem.data('confirm'))) {
                myModal.find(".modal-title").html(elem.html());
                myModal.find(".modal-body").html('Chargement en cours...');
                myModal.modal('show');
                $.ajax({
                    url: elem.data('target'),
                    method: "GET",
                    dataType: 'html',
                    success: function (data) {
                        myModal.modal('hide');
                        myModal.find(".modal-body").html(data);
                        myModal.modal('open');
                    }
                });
            }
        });

        doc.on('submit','[data-ajax-form]',function(e) {
            e.preventDefault();
            var form = $(this);
            var formBody = form.closest('.modal-body');
            $.ajax({
                url: form.attr('action'),
                method: "post",
                dataType: 'html',
                data: new FormData(form[0]),
                contentType: false,
                processData: false,
                beforeSend: function() {
                    showLoader(formBody);
                },
                success: function (data) {
                    formBody.html(data);
                    // setTimeout(function(){
                    //     location.reload();
                    // }, 4000);
                }
            });
        });

        doc.on('submit', '[data-ajax-selection]', function (e) {
            e.preventDefault();
            var selectId = null;
            var stay = null;
            var formValues = $(this).serializeArray();
            $.each(formValues, function (k, field) {
                if (field.name == 'select_id') {
                    selectId = field.value;
                } else if (field.name == 'stay') {
                    stay = field.value;
                }
            });

        });

        doc.on('click', '[name="search"]', function (e) {
            $('[name="submit"]').val($(this).val());
            var form = $(this).closest('form');
            var type = $('[name="submit"]').val();
            var selectId = null;
            var stay = null;
            var formBody = form.closest('.modal-body');
            var formValues = form.serializeArray();

            $.each(formValues, function (k, field) {
                if (field.name == 'select_id') {
                    selectId = field.value;
                } else if (field.name == 'stay') {
                    stay = field.value;
                }
            });
            if (type == 'search') {
                $.ajax({
                    url: form.attr('action'),
                    method: "post",
                    dataType: 'html',
                    data: new FormData(form[0]),
                    contentType: false,
                    processData: false,
                    beforeSend: function() {
                        showLoader(formBody);
                    },
                    success: function (data) {
                        formBody.html(data);
                    },
                });
            } else if (type == 'select'){
                $('#' + selectId).val(stay).trigger('change');
                $('#bydedi_custom_modal').modal('hide');
            }
            $(this).closest('form').submit();
        });

        doc.ajaxComplete(function () {
            $('select').select2({dropdownAutoWidth: true,'width':'100%'});
        });

        var selectedNatureOfService = $('[id$="_natureOfService"] option:selected');
        if(selectedNatureOfService[0]) {
            if (selectedNatureOfService[0].value == 'sejours') {
                $('[id$="_analyticCode"]').attr('required', false);
                $('[id$="_analyticCode"]').removeClass('inputObligatory');
            } else {
                $('[id$="_analyticCode"]').attr('required');
                $('[id$="_analyticCode"]').addClass('inputObligatory');
            }
        }
        doc.on('change', '[id$="_natureOfService"]', function (e) {
            if (e.added.id == 'sejours') {
                $('[id$="_analyticCode"]').attr('required', false);
                $('[id$="_analyticCode"]').removeClass('inputObligatory');
            } else {
                $('[id$="_analyticCode"]').attr('required');
                $('[id$="_analyticCode"]').addClass('inputObligatory');
            }

        });


        // Correctif checkbox qui ne marchent plus sans raison apparente...
        doc.on('click', 'span.check', function() {
            var label = $(this).parent('label');
            var input = label
                    .siblings('input[type="checkbox"]')
                    .not(
                        'th.sonata-ba-list-field-header-batch input[type="checkbox"], ' +
                        'td.sonata-ba-list-field-batch input[type="checkbox"], ' +
                        'div.sonata-ba-list-field-batch input[type="checkbox"]')
                ;
            if (input.prop('checked')) {
                input.prop('checked', false);
            } else {
                input.prop('checked', true);
            }
        });

        function showLoader(element) {
            element.html('<div id="loader"></div><div class="loader"></div><div class="center">Chargement en cours...</div></div>');
        }

        doc.on('click','[data-ajax-btn]',function(e) {
            e.preventDefault();
            var btn = $(this);
            var getDatas = $(this).data('datas');
            var resultType = $(this).data('type');
            var confirmReturn = $(this).data('confirm');
            if (getDatas !== null) {
                var inputValues = [];
                $.each(getDatas['params'], function(k, v) {
                    var inputs = $('[name$="[' +  v + ']"]');
                    if (inputs.length > 1) {
                        inputValues[v] = [];
                        $.each(inputs, function(index, e){
                            inputValues[v].push($(this).val());
                        });
                    } else if (inputs.length == 1) {
                        inputValues[v] = inputs.val();
                    }
                });
            }
            $.ajax({
                url: btn.data('target'),
                type: "post",
                dataType: 'json',
                data: Object.assign({}, inputValues),
                beforeSend: function() {
                    // showLoader(btn.after());
                },
                success: function (data) {
                    // $('#loader').remove();
                    switch (resultType) {
                        case 'json-input-values':
                            $.each(data, function (k, v) {
                                if($.isPlainObject(v) || $.isArray(v)) {
                                    $.each(v, function (kc, c) {
                                        var inputName = $('[name*="[' + kc + '][' + k + ']"]');
                                        var tagName = inputName.prop('tagName');
                                        // TODO : check si input ou select pour différencier l'action
                                        inputName.val(c);
                                    });
                                } else {
                                    var inputName = $('[name*="[' + k + ']"]');
                                    var tagName = inputName.prop('tagName');
                                    inputName.val(v);
                                }
                            });
                            break;
                        case 'json-input-values-confirm':
                            var exist = data.hasOwnProperty(confirmReturn);
                            function deleteInput() {
                                var inputs = $('span[id$="inscriptions"] input[id$="amount"]');
                                $.each(inputs,function(k,v){
                                    $(v).val('');
                                })
                                $('[name*="[credit]"]').val('');
                                $('[name*="[solde]"]').val('');
                            }
                            if (exist) {
                                if(data.excess == true){
                                    alert('Le montant indiqué ne peut pas être supérieur au montant total des inscriptions !')
                                    deleteInput();
                                    return false;
                                }
                                if (!confirm('Le montant indiqué ne correspond pas au montant total des inscriptions, voulez-vous continuer ?')) {
                                    deleteInput();
                                    return false;
                                }
                            }
                            $.each(data, function (k, v) {
                                if($.isPlainObject(v) || $.isArray(v)) {
                                    $.each(v, function (kc, c) {
                                        var inputName = $('[name*="[' + kc + '][' + k + ']"]');
                                        var tagName = inputName.prop('tagName');
                                        // TODO : check si input ou select pour différencier l'action
                                        inputName.val(c);
                                    });
                                } else {
                                    var inputName = $('[name*="[' + k + ']"]');
                                    var tagName = inputName.prop('tagName');
                                    inputName.val(v);
                                }
                            });
                            break;
                        default:
                            break;
                    }
                }
            });
        });

        doc.on('click','[data-delete-row]',function(e) {
            e.preventDefault();
            if (confirm('Voulez vous vraiment supprimer cette donnée ?')) {
                var element = $(this);
                var rowIndex = element.data('delete-row');
                element.parents('.field-container').first().find('[data-hidden-field][data-row="'+rowIndex+'"]').remove();
                element.parents('.field-container').first().find('[data-delete-field="'+rowIndex+'"]').prop('checked', true);
                element.parents('tr').first().remove();
            }
        });
    });
})(jQuery);
